proc init {argc argv} {
global images;
global ascii;
global switches
global swdest
global tele
global teledest
global tX
global tY
global link
global fieldwidth

source images.tcl

set ret [confirm_ask "Field Width" "6" "OK" ""]
set sel [lindex $ret 0] 
set fieldwidth [lindex $ret 1] 
if {$fieldwidth > 32} {
	set fieldwidth 32 
}

set tX 0
set tY 0

set images(TILE) [image create photo -data $tileMIME]
set images(WATER) [image create photo -data $waterMIME]
set images(ICE) [image create photo -data $iceMIME]
set images(BROKEN) [image create photo -data $brokenMIME]
set images(BIGBOMB) [image create photo -data $BigBombMIME]
set images(MEDBOMB) [image create photo -data $MedBombMIME]
set images(SMALLBOMB) [image create photo -data $SmallBombMIME]
set images(BIGMINE) [image create photo -data $BigMineMIME]
set images(SMALLMINE) [image create photo -data $SmallMineMIME]
set images(SWITCH) [image create photo -data $switchMIME]
set images(TELEPORT) [image create photo -data $teleportMIME]
set images(SHIELD) [image create photo -data $shieldMIME]
set images(SOLID) [image create photo -data $solidMIME]
set images(SWDEST) [image create photo -data $swdestMIME]
set images(TELEDEST) [image create photo -data $teledestMIME]
set images(DRONE) [image create photo -data $droneMIME]
set images(DROP) [image create photo -data $dropMIME]
set images(SPINACH) [image create photo -data $spinachMIME]

set ascii(TILE)      "#" 
set ascii(WATER)     " " 
set ascii(ICE)       "*" 
set ascii(BROKEN)    "x" 
set ascii(BIGBOMB)   "O" 
set ascii(MEDBOMB)   "o" 
set ascii(SMALLBOMB) "." 
set ascii(BIGMINE)   ">"
set ascii(SMALLMINE) "<"
set ascii(SWITCH)    "a"
set ascii(TELEPORT)  "i"
set ascii(SHIELD)    "~"
set ascii(SOLID)     "="
set ascii(SWDEST)    "A"
set ascii(TELEDEST)  "I"
set ascii(DRONE)     "?"
set ascii(SPINACH)     "S"
set ascii(DROP)      "\$"

set ascii(rev,#)	 TILE 
set ascii(rev,*)	  ICE
set ascii(rev,x)   BROKEN 
set ascii(rev,O)  BIGBOMB
set ascii(rev,o)  MEDBOMB
set ascii(rev,.) SMALLBOMB
set ascii(rev,>)   BIGMINE
set ascii(rev,<) SMALLMINE
set ascii(rev,a)	SWITCH
set ascii(rev,i)  TELEPORT
set ascii(rev,~)	SHIELD
set ascii(rev,=)	 SOLID
set ascii(rev,A)   SWDEST
set ascii(rev,I)  TELEDEST
set ascii(rev,?)	 DRONE
set ascii(rev,S)	 SPINACH
set ascii(rev,$)    DROP

set switches(0) 0
set switches(1) 0
set switches(2) 0
set switches(3) 0
set switches(4) 0
set switches(5) 0

set swdest(0) 0
set swdest(1) 0
set swdest(2) 0
set swdest(3) 0
set swdest(4) 0
set swdest(5) 0

set tele(0) 0
set tele(1) 0
set tele(2) 0
set tele(3) 0
set tele(4) 0
set tele(5) 0

set teledest(0) 0
set teledest(1) 0
set teledest(2) 0
set teledest(3) 0
set teledest(4) 0
set teledest(5) 0

set link(0) red
set link(1) aquamarine
set link(2) yellow
set link(3) magenta
set link(4) green
set link(5) orange

event delete <<Paste>> 
event delete <<Copy>> 
event delete <<Cut>>
event add <<Paste>> <Control-v>
event add <<Copy>> <Control-c>
event add <<Cut>> <Control-x>
}

proc {Window} {args} {
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs blckWindow(pre)$name] != ""} {
                eval "blckWindow(pre)$name $newname $rest"
            }
            if {[info procs blckWindow$name] != ""} {
                eval "blckWindow$name $newname $rest"
            }
            if {[info procs blckWindow(post)$name] != ""} {
                eval "blckWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

proc blckWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 200x200+0+0
    wm maxsize $base 1137 870
    wm minsize $base 96 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm withdraw $base
    wm title $base "BLCK"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc blckWindow.top {base} {
	global fieldwidth
	
    if {$base == ""} {
        set base .top
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
#    wm geometry $base 366x288+200+555
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "Bomb Level Contruction Kit"
    bind $base <Destroy> {
        exit
    }
	
    frame $base.field \
        -borderwidth 2 -height 75 -relief groove -width 125 
    frame $base.tiles \
        -borderwidth 2 -height 75 -relief groove -width 125 

	genPlayfield $base.field
	dispPlayfield $base.field $fieldwidth

	pack $base.field -side right

	genTile $base.tiles.tile TILE
	genTile $base.tiles.water WATER
	genTile $base.tiles.ice ICE
	genTile $base.tiles.broken BROKEN
	genTile $base.tiles.sw SWITCH
	genTile $base.tiles.solid SOLID
	genTile $base.tiles.shield SHIELD
	genTile $base.tiles.bigbomb BIGBOMB
	genTile $base.tiles.medbomb MEDBOMB
	genTile $base.tiles.smallbomb SMALLBOMB
	genTile $base.tiles.bigmine BIGMINE
	genTile $base.tiles.smallmine SMALLMINE
	genTile $base.tiles.swdest SWDEST
	genTile $base.tiles.teledest TELEDEST
	genTile $base.tiles.tele TELEPORT
	genTile $base.tiles.drone DRONE
	genTile $base.tiles.drop DROP
	genTile $base.tiles.spinach SPINACH

	pack $base.tiles -side right

	frame $base.fram
	button $base.fram.export -text "Export ASCII" -command [list Export $base.field]
	pack $base.fram.export -side bottom
	button $base.fram.import -text "Import ASCII" -command [list Import $base.field]
	pack $base.fram.import -side bottom
	pack $base.fram -side right
}

#################################
# MODAL DIALOG STUFF
#
option add *Confirm*icon.bitmap questhead widgetDefault
option add *Confirm*mesg.wrapLength 4i widgetDefault

proc confirm_ask {mesg entr {ok ""} {cancel ""}} {
    global confirmStatus
    global bla
    
    set top [dialog_create Confirm]
    set bla ""
    
    set info [dialog_info $top]
    label $info.icon
    pack $info.icon -side left -padx 8 -pady 8
    if {$entr != ""} {
    	set bla $entr
    	entry $info.entry -textvariable bla
    	pack $info.entry -side right -expand yes -fill both -padx 8 -pady 8
    }
    label $info.mesg -text $mesg -justify left
    pack $info.mesg -side right -expand yes -fill both -padx 8 -pady 8

    set cntls [dialog_controls $top]
    if {$ok != ""} {
		button $cntls.ok -text $ok -command {set confirmStatus 1} -default active
    	pack $cntls.ok -side left -expand yes
	    bind $top <Return> "$cntls.ok invoke"
    }
    if {$cancel != ""} {
		button $cntls.cancel -text $cancel -command {set confirmStatus 0}
    	pack $cntls.cancel -side left -expand yes
	    wm protocol $top WM_DELETE_WINDOW "$cntls.cancel invoke"
    }
	
	if {$entr != ""} {
    focus $info.entry
	} else {
    	if {$ok != ""} {
	    	focus $cntls.ok
		}
	}

    dialog_wait $top confirmStatus
    destroy $top
    return [list $confirmStatus $bla]
}

proc dialog_create {class {win "auto"}} {
    if {$win == "auto"} {
        set count 0
        set win ".dialog[incr count]"
        while {[winfo exists $win]} {
            set win ".dialog[incr count]"
        }
    }
    toplevel $win -class $class

    frame $win.info
    pack $win.info -expand yes -fill both -padx 4 -pady 4

    frame $win.sep -height 2 -borderwidth 1 -relief sunken
    pack $win.sep -fill x -pady 4

    frame $win.controls
    pack $win.controls -fill x -padx 4 -pady 4

    wm title $win "Select"
    wm group $win .
        
    after idle [format {
        update idletasks
        wm minsize %s [winfo reqwidth %s] [winfo reqheight %s]
    } $win $win $win]

    set x [expr [winfo pointerx $win] - 50]
    set y [expr [winfo pointery $win] - 50]
    wm geometry $win "+$x+$y"
	
    return $win
}

proc dialog_info {win} {
    return "$win.info"
}

proc dialog_controls {win} {
    return "$win.controls"
}

proc dialog_wait {win varName} {
    dialog_safeguard $win

    set x [expr [winfo pointerx $win] - 50]
    set y [expr [winfo pointery $win] - 50]
    wm geometry $win "+$x+$y"

    wm deiconify $win
    catch {tkwait visibility $win}
    catch {grab set $win}

    vwait $varName

    catch {grab release $win}
    wm withdraw $win
}

bind modalDialog <ButtonPress> {
    wm deiconify %W
    raise %W
}

proc dialog_safeguard {win} {
    if {[lsearch [bindtags $win] modalDialog] < 0} {
        bindtags $win [linsert [bindtags $win] 0 modalDialog]
    }
}

################################################################################

proc Export {name} {
    global confirmStatus
    global bla
	
    set top [dialog_create auto]
    set bla ""
    set info [dialog_info $top]

	frame $info.fram
	pack $info.fram -side top
	label $info.fram.lab -text "Level" 
    pack $info.fram.lab
	text $info.fram.text -width 32 -height 10
	pack $info.fram.text
	label $info.fram.lab2 -text "Switches" 
    pack $info.fram.lab2
	text $info.fram.text2 -width 32 -height 1
	pack $info.fram.text2
	
	BuildExport $name $info.fram
			
    set cntls [dialog_controls $top]
    button $cntls.ok -text "OK" -command {set confirmStatus 1} -default active
    pack $cntls.ok

    wm protocol $top WM_DELETE_WINDOW "$cntls.cancel invoke"
    bind $top <Return> "$cntls.ok invoke"

    dialog_wait $top confirmStatus
    destroy $top
}

proc Import {name} {
    global confirmStatus
    global bla
	global importline
	global importsw
	global fieldwidth
	
	
	
    set top [dialog_create auto]
    set bla ""
    set info [dialog_info $top]

	frame $info.fram
	pack $info.fram -side top
	
	label $info.fram.lab -text "Level map (ASCII)" 
    pack $info.fram.lab -side top
	text $info.fram.text -width 32 -height 10
	pack $info.fram.text -side top
	label $info.fram.lab2 -text "Switchable tiles (ASCII)" 
    pack $info.fram.lab2 -side top
	text $info.fram.swtext -width 32 -height 1
	pack $info.fram.swtext -side top

    set cntls [dialog_controls $top]
    button $cntls.ok -text "OK" -command {set confirmStatus 1} -default active
    pack $cntls.ok

    wm protocol $top WM_DELETE_WINDOW "$cntls.ok invoke"
#    bind $top <Return> "$cntls.ok invoke"

    dialog_wait $top confirmStatus

	set i 0
	set line "foo"
	while {$line != ""} {
		set j [expr $i + 1]
		set line [$info.fram.text get $j.0 $j.end]
		if {$line != ""} {
			if {[regexp {\"(.*)\"} $line match importline($i)] == 0} {
				confirm_ask "Syntax error in level!" "" "OK"
				return -1			
			}
			puts $importline($i)
			incr i
		}
	}
	
	set importsw ""
	set line [$info.fram.swtext get 1.0 1.end]
	if {$line==""} {
		set line "\"\""
	}		
    if {[regexp {\"(.*)\"} $line match importsw] == 0} {
		confirm_ask "Syntax error in switch string!" "" "OK"
		return -1
	}
	puts $importsw
	
    destroy $top

	set len [string length $importline(0)]
	if {$len > 32} {
		confirm_ask "Max playfield size is 32!" "" "OK"
		return 0
	}
	if {$len != $i} {
		confirm_ask "Level playfield has to be quare!" "" "OK"
		return 0
	}

	
	if {[ParseImport $name $len] ==0} {
    	for {set x 0} {$x < $fieldwidth} {incr x} {
    		for {set y 0} {$y < $fieldwidth} {incr y} {
				grid remove $name.$x-$y
			}
		}
		set fieldwidth $len
		dispPlayfield $name $fieldwidth
	}
}

proc ParseImport {name w} {
global importline
global importsw
global playField
global playFieldAux
global ascii
global images
global link
global tele
global teledest
global switches
global swdest
global onTile
global offTile

    for {set l 0} {$l < $w} {incr l} {
		puts $importline($l)
    	for {set i 0} {$i < $w} {incr i} {
			set x $i
			set y $l
			set c [string index $importline($l) $i]
			$name.$x-$y configure -background black
		    if {$c>="a" && $c<="f" } {
				set n [expr [scan $c %c] - 97]
				$name.$x-$y configure -background $link($n)
				set playFieldAux($name.$x-$y) $n
				set switches($n) 1
				set c "a"
		    }
		    if {$c>="i" && $c<="n"} {
				set n [expr [scan $c %c] - 105]
				$name.$x-$y configure -background $link($n)
				set playFieldAux($name.$x-$y) $n
				set tele($n) 1
				set c "i"
		    }
		    if {$c>="A" && $c<="F" } {
				set n [expr [scan $c %c] - 65]
				$name.$x-$y configure -background $link($n)
				set playFieldAux($name.$x-$y) $n
				set swdest($n) 1
				set onTile($n) WATER
				set offTile($n) WATER
				set c "A"
		    }
		    if {$c>="I" && $c<="N"} {
				set n [expr [scan $c %c] - 73]
				$name.$x-$y configure -background $link($n)
				set playFieldAux($name.$x-$y) $n
				set teledest($n) 1
				set c "I"
		    }
			if {$c==" "} {
				set playField($name.$x-$y) WATER
			} else {
				set playField($name.$x-$y) $ascii(rev,$c)
			}
			$name.$x-$y configure -image $images($playField($name.$x-$y))
		}
	}
	
	if {[expr [string length $importsw] % 3] != 0} {
		confirm_ask "Three bytes per switch string entry!" "" "OK"
		return -1
	}
	
    for {set i 0} {$i < [string length $importsw]} {incr i} {
		set c [string index $importsw $i]
    	set n [expr [scan $c %c] - 97]
		puts $n
		if {$swdest($n) == 0} {
			confirm_ask "Switch string entry for unused switch!" "" "OK"
			return -2
		}
		incr i
		set c [string index $importsw $i]
		if {$c==" "} {
			set onTile($n) WATER
		} else {
			set onTile($n) $ascii(rev,$c)
		}
		incr i
		set c [string index $importsw $i]
		if {$c==" "} {
			set offTile($n) WATER
		} else {
			set offTile($n) $ascii(rev,$c)
		}
	}	
	
	return 0
}

proc ShowFieldInfo {name x y} {
global playField
global playFieldAux
global onTile
global offTile
global images
	if {$playField($name) == "SWDEST"} {
		$name.popmenu entryconfigure 0 -image $images($onTile($playFieldAux($name)))
		$name.popmenu entryconfigure 1 -image $images($offTile($playFieldAux($name)))
		tk_popup $name.popmenu $x $y	
	}
}

proc teleselPop {base i} {
	global teleselect
	set teleselect $i
	$base configure -text $i
}

proc tileSelectionOn {base} {
global images
global selStateOn

	checkbutton $base.tile -image $images(TILE) -onvalue TILE -offvalue 0 -variable selStateOn
	pack $base.tile
	checkbutton $base.water -image $images(WATER) -onvalue WATER -offvalue 0 -variable selStateOn
	pack $base.water
	checkbutton $base.ice -image $images(ICE) -onvalue ICE -offvalue 0 -variable selStateOn
	pack $base.ice
	checkbutton $base.broken -image $images(BROKEN) -onvalue BROKEN -offvalue 0 -variable selStateOn
	pack $base.broken
	checkbutton $base.solid -image $images(SOLID) -onvalue SOLID -offvalue 0 -variable selStateOn
	pack $base.solid
	checkbutton $base.shield -image $images(SHIELD) -onvalue SHIELD -offvalue 0 -variable selStateOn
	pack $base.shield
	checkbutton $base.bigbomb -image $images(BIGBOMB) -onvalue BIGBOMB -offvalue 0 -variable selStateOn
	pack $base.bigbomb
	checkbutton $base.medbomb -image $images(MEDBOMB) -onvalue MEDBOMB -offvalue 0 -variable selStateOn
	pack $base.medbomb
	checkbutton $base.smallbomb -image $images(SMALLBOMB) -onvalue SMALLBOMB -offvalue 0 -variable selStateOn
	pack $base.smallbomb
	checkbutton $base.bigmine -image $images(BIGMINE) -onvalue BIGMINE -offvalue 0 -variable selStateOn
	pack $base.bigmine
	checkbutton $base.smallmine -image $images(SMALLMINE) -onvalue SMALLMINE -offvalue 0 -variable selStateOn
	pack $base.smallmine
	checkbutton $base.spinach -image $images(SPINACH) -onvalue SPINACH -offvalue 0 -variable selStateOn
	pack $base.spinach
#	checkbutton $base.tele -image $images(TELEPORT) -onvalue TELEPORT -offvalue 0 -variable selStateOn
#	pack $base.tele
}

proc tileSelectionOff {base} {
global images
global selStateOff

	checkbutton $base.tile -image $images(TILE) -onvalue TILE -offvalue 0 -variable selStateOff
	pack $base.tile
	checkbutton $base.water -image $images(WATER) -onvalue WATER -offvalue 0 -variable selStateOff
	pack $base.water
	checkbutton $base.ice -image $images(ICE) -onvalue ICE -offvalue 0 -variable selStateOff
	pack $base.ice
	checkbutton $base.broken -image $images(BROKEN) -onvalue BROKEN -offvalue 0 -variable selStateOff
	pack $base.broken
	checkbutton $base.solid -image $images(SOLID) -onvalue SOLID -offvalue 0 -variable selStateOff
	pack $base.solid
	checkbutton $base.shield -image $images(SHIELD) -onvalue SHIELD -offvalue 0 -variable selStateOff
	pack $base.shield
	checkbutton $base.bigbomb -image $images(BIGBOMB) -onvalue BIGBOMB -offvalue 0 -variable selStateOff
	pack $base.bigbomb
	checkbutton $base.medbomb -image $images(MEDBOMB) -onvalue MEDBOMB -offvalue 0 -variable selStateOff
	pack $base.medbomb
	checkbutton $base.smallbomb -image $images(SMALLBOMB) -onvalue SMALLBOMB -offvalue 0 -variable selStateOff
	pack $base.smallbomb
	checkbutton $base.bigmine -image $images(BIGMINE) -onvalue BIGMINE -offvalue 0 -variable selStateOff
	pack $base.bigmine
	checkbutton $base.smallmine -image $images(SMALLMINE) -onvalue SMALLMINE -offvalue 0 -variable selStateOff
	pack $base.smallmine
	checkbutton $base.spinach -image $images(SPINACH) -onvalue SPINACH -offvalue 0 -variable selStateOff
	pack $base.spinach
#	checkbutton $base.tele -image $images(TELEPORT) -onvalue TELEPORT -offvalue 0 -variable selStateOff
#	pack $base.tele
}

proc SelectSwitchDest {} {
    global confirmStatus
    global bla
    global swdest
	global teleselect
	global selStateOn
	global selStateOff
	global onTile
	global offTile
	
    set top [dialog_create auto]
    set bla ""
    set info [dialog_info $top]

	frame $info.fram
	pack $info.fram -side top
	label $info.fram.lab -text "Select Switch Number" 
    pack $info.fram.lab -side right -padx 8 -pady 8

    set c 0
	menu $info.popmenu -tearoff 0
    for {set i 0} {$i < 6} {incr i} {
		if {$swdest($i) == 0} {
			set teleselect $i
			incr c
			$info.popmenu add command -label $i -command [list teleselPop $info.fram.popbut $i]
		}
	}
	if {$c == 0} {
		label $info.fram.popbut -text "All switch destinations already used" -borderwidth 2 -relief raised -padx 10
		set teleselect -1
	} else {
		label $info.fram.popbut -text $teleselect -borderwidth 2 -relief raised -padx 10
	    bind $info.fram.popbut <ButtonPress-1> [list tk_popup $info.popmenu %X %Y]
	}
    pack $info.fram.popbut -side right

	set selStateOn $onTile($teleselect)
	set selStateOff $offTile($teleselect)
	
	frame $info.framOn
	pack $info.framOn -side left -anchor w
	label $info.framOn.lab -text "On"
	pack $info.framOn.lab
	tileSelectionOn $info.framOn

	frame $info.framOff
	pack $info.framOff -side right -anchor e
	label $info.framOff.lab -text "Off"
	pack $info.framOff.lab
	tileSelectionOff $info.framOff
		
    set cntls [dialog_controls $top]
    button $cntls.ok -text "OK" -command {set confirmStatus 1} -default active
    pack $cntls.ok

    wm protocol $top WM_DELETE_WINDOW "$cntls.cancel invoke"
    bind $top <Return> "$cntls.ok invoke"

    dialog_wait $top confirmStatus
    destroy $top

	set onTile($teleselect) $selStateOn
	set offTile($teleselect) $selStateOff
	set swdest($teleselect) 1
	return $teleselect
}

proc SelectSwitch {} {
    global confirmStatus
    global bla
    global switches
	global teleselect
	
    set top [dialog_create auto]
    set bla ""
    set info [dialog_info $top]

	label $info.lab -text "Select Switch Number" 
    pack $info.lab -side left -padx 8 -pady 8

    set c 0
	menu $info.popmenu -tearoff 0
    for {set i 0} {$i < 6} {incr i} {
		if {$switches($i) == 0} {
			set teleselect $i
			incr c
			$info.popmenu add command -label $i -command [list teleselPop $info.popbut $i]
		}
	}
	if {$c == 0} {
		label $info.popbut -text "All switches already used" -borderwidth 2 -relief raised -padx 10
		set teleselect -1
	} else {
		label $info.popbut -text $teleselect -borderwidth 2 -relief raised -padx 10
	    bind $info.popbut <ButtonPress-1> [list tk_popup $info.popmenu %X %Y]
	}
    pack $info.popbut -side left -padx 8 -pady 8 

	 	
    set cntls [dialog_controls $top]
    button $cntls.ok -text "OK" -command {set confirmStatus 1} -default active
    pack $cntls.ok -side left -expand yes

    wm protocol $top WM_DELETE_WINDOW "$cntls.cancel invoke"
    bind $top <Return> "$cntls.ok invoke"

    dialog_wait $top confirmStatus
    destroy $top

	set switches($teleselect) 1
	return $teleselect
}

proc SelectTeleporter {} {
    global confirmStatus
    global bla
    global tele
	global teleselect
	
    set top [dialog_create auto]
    set bla ""
    set info [dialog_info $top]

	label $info.lab -text "Select Teleporter Number" 
    pack $info.lab -side left -padx 8 -pady 8

    set c 0
	menu $info.popmenu -tearoff 0
    for {set i 0} {$i < 6} {incr i} {
		if {$tele($i) == 0} {
			set teleselect $i
			incr c
			$info.popmenu add command -label $i -command [list teleselPop $info.popbut $i]
		}
	}
	if {$c == 0} {
		label $info.popbut -text "All teleporters already used" -borderwidth 2 -relief raised -padx 10
		set teleselect -1
	} else {
		label $info.popbut -text $teleselect -borderwidth 2 -relief raised -padx 10
	    bind $info.popbut <ButtonPress-1> [list tk_popup $info.popmenu %X %Y]
	}
	
    pack $info.popbut -side left -padx 8 -pady 8 

	 	
    set cntls [dialog_controls $top]
    button $cntls.ok -text "OK" -command {set confirmStatus 1} -default active
    pack $cntls.ok -side left -expand yes

    wm protocol $top WM_DELETE_WINDOW "$cntls.cancel invoke"
    bind $top <Return> "$cntls.ok invoke"

    dialog_wait $top confirmStatus
    destroy $top

	set tele($teleselect) 1
	return $teleselect
}

proc SelectTeleporterDest {} {
    global confirmStatus
    global bla
    global teledest
	global teleselect
	
    set top [dialog_create auto]
    set bla ""
    set info [dialog_info $top]

	label $info.lab -text "Select Teleporter Number" 
    pack $info.lab -side left -padx 8 -pady 8

    set c 0
	menu $info.popmenu -tearoff 0
    for {set i 0} {$i < 6} {incr i} {
		if {$teledest($i) == 0} {
			set teleselect $i
			incr c
			$info.popmenu add command -label $i -command [list teleselPop $info.popbut $i]
		}
	}

	if {$c == 0} {
		label $info.popbut -text "All teleporter destinations already used" -borderwidth 2 -relief raised -padx 10
		set teleselect -1
	} else {
		label $info.popbut -text $teleselect -borderwidth 2 -relief raised -padx 10
	    bind $info.popbut <ButtonPress-1> [list tk_popup $info.popmenu %X %Y]
	}
	
    pack $info.popbut -side left -padx 8 -pady 8 

	 	
    set cntls [dialog_controls $top]
    button $cntls.ok -text "OK" -command {set confirmStatus 1} -default active
    pack $cntls.ok -side left -expand yes

    wm protocol $top WM_DELETE_WINDOW "$cntls.cancel invoke"
    bind $top <Return> "$cntls.ok invoke"

    dialog_wait $top confirmStatus
    destroy $top

	set teledest($teleselect) 1
	return $teleselect
}

proc SetLast {w} {
    global _dragwidget
	global tiles
	global playField
	global playFieldAux
	global link
	global tele
	global teledest
	global switches
	global swdest
	
	if {$_dragwidget != {}} {
 	  	$w configure -background black
		
		if {$playField($w) == "TELEPORT" } {
			set tele($playFieldAux($w)) 0
		}
		if {$playField($w) == "TELEDEST" } {
			set teledest($playFieldAux($w)) 0
		}
		if {$playField($w) == "SWITCH" } {
			set switches($playFieldAux($w)) 0
		}
		if {$playField($w) == "SWDEST" } {
			set swdest($playFieldAux($w)) 0
		}
		
		if {$tiles($_dragwidget) == "TELEPORT"} {
			set n [SelectTeleporter]	
			if {$n == -1} {
				return
			}
			set playFieldAux($w) $n
 	  		$w configure -background $link($n) -borderwidth 2 -relief flat
		}
		if {$tiles($_dragwidget) == "SWITCH"} {
			set n [SelectSwitch]	
			if {$n == -1} {
				return
			}
			set playFieldAux($w) $n
 	  		$w configure -background $link($n) -borderwidth 2 -relief flat
		}
 	  	$w configure -image [ $_dragwidget cget -image]
		set playField($w) $tiles($_dragwidget)
		if {$playField($w) == "TELEDEST"} {
			set n [SelectTeleporterDest]	
			if {$n == -1} {
				return
			}
			set playFieldAux($w) $n
 	  		$w configure -background $link($n) -borderwidth 2 -relief flat
		}
		if {$playField($w) == "SWDEST"} {
			set n [SelectSwitchDest]	
			if {$n == -1} {
				return
			}
			set playFieldAux($w) $n
 	  		$w configure -background $link($n) -borderwidth 2 -relief flat
		}
	}
}

proc drag {command args} {
    global _dragging
    global _lastwidget
    global _dragwidget
	global tiles
	global playField

    switch $command {
        init {
            # one-time code to initialize variables
            set _lastwidget {}
            set _dragging 0
            set _dragwidget {}
        }

        start {
            set w [lindex $args 0]
            set _dragging 1
            set _lastwidget $w
            set _dragwidget $w
            $w configure -cursor hand2
        }

        motion {
            if {!$_dragging} {return}

            set x [lindex $args 0]
            set y [lindex $args 1]
            set w [winfo containing $x $y]
            if {$w != $_lastwidget && [winfo exists $_lastwidget]} {
                event generate $_lastwidget <<DragLeave>>
            }
            set _lastwidget $w
            if {[winfo exists $w]} {
                event generate $w <<DragOver>>
            }
        }

        stop {
            if {!$_dragging} {return}
            set x [lindex $args 0]
            set y [lindex $args 1]
            set w [winfo containing $x $y]
            if {[winfo exists $w]} {
                event generate $w <<DragLeave>>
                event generate $w <<DragDrop>>
            }
            set _dragging 0
            $_dragwidget configure -cursor {}
        }

        over {
            if {!$_dragging} {return}
            set w [lindex $args 0]
            $w configure -state active
        }

        leave {
            if {!$_dragging} {return}
            set w [lindex $args 0]
            $w configure -state normal
            $w configure -cursor {}
        }

        drop {
            set w [lindex $args 0]
            $w configure -state normal
            $w configure -image [ $_dragwidget cget -image]
			SetLast $w
        }
    }
}


proc genTile {name type} {
global images;
global tiles
global tX
global tY
	button $name -image $images($type)
	grid $name -row $tX -column $tY
	incr tX
	if {($tX%5) == 0} {
		set tX 0
		incr tY
	}
    bind $name <ButtonPress-1>   [list drag start %W]
    bind $name <Motion>          [list drag motion %X %Y]
    bind $name <ButtonRelease-1> [list drag stop %X %Y]
	set tiles($name) $type
}

proc genField {name x y type} {
global images;
global playField
global playFieldAux

	button $name -image $images($type) -relief flat -borderwidth 2 -background black -activebackground white -command [list SetLast $name]
    bind $name <<DragOver>>      [list drag over %W]
    bind $name <<DragLeave>>     [list drag leave %W]
    bind $name <<DragDrop>>      [list drag drop  %W]
    bind $name <ButtonPress-3>   [list ShowFieldInfo %W %X %Y]
	set playField($name) $type
	set playFieldAux($name) 0

	menu $name.popmenu -tearoff 0
	$name.popmenu add command -image $images(WATER)
	$name.popmenu add command -image $images(WATER)
}

proc genPlayfield {name} {
global onTile
global offTile
    for {set y 0} {$y < 32} {incr y} {
    	for {set x 0} {$x < 32} {incr x} {
			genField "$name.$x-$y" $x $y WATER
    	}
    }
    for {set i 0} {$i < 6} {incr i} {
		set onTile($i) WATER
		set offTile($i) WATER
	}
}

proc dispPlayfield {name w} {
global fieldwidth;

	set fieldwidth $w

    for {set y 0} {$y < $w} {incr y} {
    	for {set x 0} {$x < $w} {incr x} {
			grid $name.$x-$y -row $y -column $x -padx 0 -pady 0 -ipadx 0 -ipady 0
    	}
    }
}

proc BuildExport {name w} {
global fieldwidth;
global playField
global playFieldAux
global ascii
global onTile
global offTile
global swdest

    for {set y 0} {$y < $fieldwidth} {incr y} {
		set row [string repeat "#" $fieldwidth]
    	for {set x 0} {$x < $fieldwidth} {incr x} {
			set c $ascii($playField($name.$x-$y))
			if {($playField($name.$x-$y) == "TELEPORT") || ($playField($name.$x-$y) == "TELEDEST") || ($playField($name.$x-$y) == "SWITCH") || ($playField($name.$x-$y) == "SWDEST")} {
				scan $ascii($playField($name.$x-$y)) %c c
				set c [expr $c + $playFieldAux($name.$x-$y)]
				set c [format %c $c]
			}
			set row [string replace $row $x $x $c]
    	}
		puts "\"$row\""
		$w.text insert end "\"$row\"\n"
    }
	set row ""
    set j 0
	set k 0
	for {set i 0} {$i < 6} {incr i} {
		if {$swdest($k) != 0} {
			append row [format %c [expr 97 + $k]]
			incr j
			append row $ascii($onTile($k))
			incr j
			append row $ascii($offTile($k))
			incr j
		}
		incr k
		
	}
	puts "\"$row\""
	$w.text2 insert end "\"$row\"\n"
}



init $argc $argv
drag init
Window show .
Window show .top


 
